Program Osszesito;
{Osszesito pr.
 Parancssor: Tesztknyvtr v
 Input: Feladatnev.GRD ertekelo allomanyok az aktualis konyvtarban
 Output: EREDMENY.TXT
}
Const
  MaxFszam=5;                        { a feladatok max. szma }
  MaxTe   =20;                       { a tesztesetek max. szma }
  MaxRf   =20;                       { a rszfeladatok max. szma }
Var
  DefNev,                            { feladatleiro fajl }
  TeK:String;                        { Tesztknyvtr }
  FPont,                             { elrhet pontszmok }
  EPont:Array[1..MaxFszam,1..MaxTe,1..MaxRf] of Integer;{elrt pontszmok }
  MSG:Array[1..MaxFszam,1..MaxTe,1..MaxRf] of String[80];{a hibazenetek}
  FNev:Array[1..MaxFszam] of String; { a feladatnevek }
  Tesz:Array[1..MaxFszam] of Byte;   { a tesztesek szma feladatonknt }
  Rf:Array[1..MaxFszam] of Byte;     { a rszfeladatok szma feladatonknt }
  Tlim:Array[1..MaxFszam] of Real;   { az idlimit }
  RTime:Array[1..MaxFszam,1..MaxTe] of Longint;
  Fszam,                             { a feladatok szma }
  MOP,                               { max. sszpontszm }
  OP:Word;                           { sszpontszm }
  Def,                               { Feladatleir fjl}
  FErtf,                             { a feladat ert fjl }
  OErtf:Text;                        { az sszesitett rtkelsi fjl  }
  MPont,                             { a feladatonknti max. sszpontszm }
  Pont:Array[1..MaxFszam] of Integer;{ a feladatonknt elrt sszpontszm }
  i,j,r,x:word;
Begin
  TeK:=ParamStr(1)+'\';
{  DefNev:=ParamStr(2);}
  Assign(Def,TeK+'verseny.dat');     { a feladatok adatainak beolvassa }
  Reset(Def);

  ReadLn(Def,Fszam);                 { a feladatok szma }
  MOP:=0;
  For i:=1 To Fszam Do Begin
    MPont[i]:=0;
    ReadLn(Def,FNev[i]);             { a feladat neve }
    ReadLn(Def,Tlim[i]);             { a feladat neve }
    ReadLn(Def,Tesz[i]);             { a tesztesetek szma }
    ReadLn(Def,Rf[i]);               { a rszfeladatok szma }
    For r:=1 To Rf[i] Do Begin       { a pontszmok }
      For j:=1 To Tesz[i] Do Begin
        Read(Def,FPont[i,j,r]);
        MPont[i]:=MPont[i]+FPont[i,j,r];
      End;
      ReadLn(Def);
    End;
    MOP:=MOP+MPont[i];
  End;
  Close(Def);

  For i:=1 To Fszam Do Begin         { az rtekelsbol szrmaz adatatok }
    Assign(FErtf,FNev[i]+'.GRD');    { FELADATNV.GRD fjl }
    {$I-}
      Reset(FErtf);
    {$I+}
    If IOResult<>0 Then Begin
      WriteLn(FNev[i]+'.GRD llomny nem tallhat!');
      exit;
    End;
    Pont[i]:=0;
    For r:=1 To Rf[i] Do Begin
      For j:=1 To Tesz[i] Do Begin
        Read(FErtf,x);               { x=0 v. 1}
        EPont[i,j,r]:=x*FPont[i,j,r];
        Pont[i]:=Pont[i]+EPont[i,j,r];
      End;
      ReadLn(FErtf);
    End;

    For j:=1 To Tesz[i] Do Begin
      For r:=1 To Rf[i] Do Begin
        ReadLn(FErtf, MSG[i,j,r]);               { a hibauzenet}
      End;
    End;

    For j:=1 To Tesz[i] Do Begin
      Read(FErtf, RTime[i,j]);                  { futasi ido}
    End; ReadLn(FErtf);

   Close(FErtf);
{
   For j:=1 To Tesz[i] Do Begin
     If 5.0*RTime[i,j]/91 > TLim[i] Then Begin
       MSG[i,j,1]:='Idolimit tullepes';
       For r:=1 To Rf[i] Do Begin
         Pont[i]:=Pont[i]-EPont[i,j,r];
         EPont[i,j,r]:=0;
       End;
     End;
   End;
}
End;

  Assign(OErtf,'EREDMENY.TXT');      { az sszesits kiiratssa }
  Rewrite(OErtf);
  WriteLn(OErtf,'              Pont/teszteset');
  WriteLn('              Pont/teszteset');
  WriteLn(OErtf,'Feladat:      1. 2. 3. 4. 5. 6. 7. 8. 9. a. b. c. d. e. f. g.'+
                ' h. i. j. k.');
  WriteLn('Feladat:      1. 2. 3. 4. 5. 6. 7. 8. 9. a. b. c. d. e. f. g. h. i.'+
          ' j. k.');

  For i:=1 to 73 Do Begin
    Write(OErtf,'-');
    Write('-');
  End;
  WriteLn(OErtf);
  WriteLn;
  OP:=0;
  For i:=1 To Fszam Do Begin         { a feladadok rtkelsi adatai }
    OP:=OP+Pont[i];
    Write(OErtf,FNev[i]:8,'(',MPont[i]:2,')');
    Write(FNev[i]:8,'(',MPont[i]:2,')');
    For r:=1 To Rf[i] Do Begin
      If r<>1 Then Begin
        Write(OErtf,' ':13);
        Write(' ':13);
      End;
      For j:=1 To Tesz[i] Do Begin
        Write(OErtf,EPont[i,j,r]:3);
        Write(EPont[i,j,r]:3);
      End{for j};
      If r<>Rf[i] Then Begin
        WriteLn(OErtf);
        WriteLn;
      End;
    End{for r};
    Write(OErtf,' ':(MaxTe-Tesz[i])*3+1,'=');
    Write(' ':(MaxTe-Tesz[i])*3+1,'=');
    WriteLn(OErtf,Pont[i]:3);
    WriteLn(Pont[i]:3);

  End{for i};
  For i:=1 to 73 Do Begin
    Write(OErtf,'-');
    Write('-');
  End;
  WriteLn(OErtf);
  WriteLn;
  WriteLn(OErtf,'Max.(':8,MOP:3,')','sszpontszm = ':63,OP);
  WriteLn('Max.(':8,MOP:3,')','sszpontszm = ':63,OP);
  WriteLn(OErtf);
  WriteLn;

  WriteLn(OErtf,'rtkelsi zenetek:');
  WriteLn(OErtf,'********************');
  For i:=1 To Fszam Do Begin
    Write(OErtf,FNev[i]);
   For j:=1 To 71-Length(FNev[i]) Do Write(OErtf,'-'); WriteLn(OErtf);
    For j:=1 To Tesz[i] Do Begin
      For r:=1 To Rf[i] Do Begin
        WriteLn(OErtf, MSG[i,j,r]);               { a hibauzenet}
      End;
    End;
    WriteLn(OErtf,'Futsi id(mp)/teszteset:');
    For j:=1 To Tesz[i] Do Begin
      If RTime[i,j]<0 Then
        Write(OErtf,'-':6)
      Else
        Write(OErtf, (5.0*RTime[i,j])/91:6:2);         { futasi ido}
    End;
    WriteLn(OErtf);
  End{for i};
  Close(OErtf);

End.
